/**
 * Created by root on 21.03.14.
 */
var events = require("events");


var utils = {};
module.exports = utils;

utils.releaseMode = false;
utils.oo = function() {

    var extend=function(target, source)
    {
        source = new source();
        for(var property in source)
        {
            //if(source.hasOwnProperty(property))
                if(!target.hasOwnProperty(property))
                    target[property] = source[property];
        }
    };
    var implement=function(target, source)
    {
        source = new source();
        if(!utils.releaseMode)
        {
            for(var property in source)
            {
                if(source.hasOwnProperty(property))
                    if(!target.hasOwnProperty(property))
                        throw( property + " property not implemented");
            }
        }


        return target;
    };
    var Class = function(ancestors, interfaces, contructor)
        {
            return function()
            {
                extend(this,contructor);

                if(!Array.isArray(ancestors)) ancestors = [ancestors];
                if(!Array.isArray(interfaces)) interfaces = [interfaces];

                if(ancestors[0])
                    for(var i = 0; i < ancestors.length; i++)
                    {
                        extend(this,ancestors[i]);
                    }
                if(interfaces[0])
                    for(i = 0; i < interfaces.length; i++)
                    {
                        implement(this,interfaces[i]);
                    }
            };
        };
    return{
        Class: Class,
        extend : extend,
        implement:implement
    }
}();
utils.pattern = function() {
    var Subject = function()
    {
        this.subscribers = [];
    };
    Subject.prototype.notify = function(event)
    {
        var i = this.subscribers.length;
        while(i-- > 0)
        {
           this.subscribers[i].update(this,event);
        }
    };
    Subject.prototype.subscribe = function(obj)
    {
        if(this.subscribers.indexOf(obj) == -1)this.subscribers.push(obj);
    };
    Subject.prototype.unsubscribe = function(obj)
    {
        this.subscribers.splice(this.subscribers.indexOf(obj),1);
    };

    var IObserver = function(){
        this.update = function(subject,changed){};
    };

    return {
        Subject: Subject,
        IObserver: IObserver
    }
}();

utils.releaseMode = null;
var TestSubject = utils.oo.Class(utils.pattern.Subject, null, function Test()
{

});
var TestObserver = utils.oo.Class(null, utils.pattern.IObserver, function Test()
{
    this.update = function(target, event)
    {
        console.log(target, event)
    }
});
utils.test = function(func, times)
{
    var time = Date.now();
    for(var i = 0; i < times; i++)
    {
        func();
    }
    return Date.now()-time;
};

var testS = new TestSubject();
var testO = new TestObserver();

var emitter = new events.EventEmitter();


var _eventsList = ["test"];
var times = 10000000;

var timesLi = 0;

var li = [];
function getList ()
{
    if(!(timesLi++%2))
    {
        console.log("Time " + (timesLi-1)/2);
        li.push(timesLi.toString());
    }
    return li;
}

testA();

function testA()
{
    var eventsList = getList();

    var counter = 0;
    var time = Date.now();
    var len = eventsList.length;
    for(var i = 0 ; i < len; i++)
    {
        emitter.on(eventsList[i],function()
        {
            if(++counter == times)
            {
                console.log(Date.now()-time);
                testB();
            }
        });
    }
    for(var i = 0 ; i < times; i++)
    {
        var tmp = eventsList.shift();
        eventsList.push(tmp);

        emitter.emit(tmp);
    }

}

function testB()
{
    var eventsList = getList();

    testS.subscribe(testO);
    testO.update = function(target,event)
    {
        var len = eventsList.length;
        for(var i = 0; i < len; i++)
        {
            if(eventsList[i] == event)
            {
                if(++counter == times)
                {
                    console.log(Date.now()-time);
                    testA();
                }

            }
        }
    };
    var time = Date.now();
    var counter = 0;
    for(var i = 0 ; i < times; i++)
    {
        var tmp = eventsList.shift();
        eventsList.push(tmp);
        testS.notify(tmp);
    }
}